=== debian/changelog ===
texworks (0.6.9-2) unstable; urgency=medium

  * Limit autopkg test to LE arches as long as #1059943 is not solved.

 -- Hilmar Preuße <hille42@debian.org>  Sat, 06 Jul 2024 00:24:02 +0200

texworks (0.6.9-1) unstable; urgency=medium

  * New upstream version, disable obsolete patches.

 -- Hilmar Preusse <hille42@web.de>  Sun, 19 May 2024 12:49:25 +0200

texworks (0.6.8-3) unstable; urgency=medium

  * Patches from upstream:
    - 417ac77edbeac78403541c1653843fc9451faf90
      [PATCH] <QtPDF> Fix Qt6 warnings
    - 5476b35b6211b34bdf49ecd9b5c8abb2edca9b9f
      [PATCH] Fix Qt 6.4 warnings
    - 7c6dbeac3ecebd409bde142601314ad58f9b0fc4
      [PATCH] Fix display of version date/time with Qt6
    - 95d9b019b1dc6c7ab8286f7184c4dbbae108cdc2
      [PATCH] Fix Qt6 warnings
    - e6fb33b44f5736e98b8c34c5a3296a342394c3fa
      [PATCH] Fix compilation with Qt 6.5

 -- Hilmar Preusse <hille42@web.de>  Sun, 11 Jun 2023 23:43:47 +0200

texworks (0.6.8-2) experimental; urgency=medium

  * Switch to QT6.
  * Remove liblua5.2-dev as alternative B-D, add liblua5.4-dev.

 -- Hilmar Preusse <hille42@web.de>  Wed, 22 Feb 2023 23:31:48 +0100
