=== debian/changelog ===
texworks (0.6.10+ds-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 22 Jan 2026 22:03:27 +0000

texworks (0.6.10+ds-1) unstable; urgency=medium

  * New upstream release, disable obsolete patches.
  * Lintian: build-depends-on-obsolete-package
    + Add lintian overrides.
    + no-dep5-copyright
  * Bump Standards version, no changes needed.

 -- Hilmar Preuße <hille42@debian.org>  Sat, 15 Feb 2025 17:25:39 +0100
